#ifndef GOERTZEL_H
#define GOERTZEL_H 1

typedef struct {
    int idx;          /* index into x[] array */
    int N;            /* N is the filter length, in samples */
    double *xOmegar;  /* ith value of Re(x_i*Omega) */
    double *xOmegai;  /* ith value of Im(x_i*Omega) */
    double gr;
    double gi;
    double Omega_nr;
    double Omega_ni;
    double Omegar;              /* cos(2\pi\omega) */
    double Omegai;              /* sin(2\pi\omega) */
} GoertzelFilter;

GoertzelFilter* goertzel_init(GoertzelFilter*,
                              double freq, /* in Hertz (ie cycles per second) */
                              int samp_per_sec, /* samples per second */
                              double filter_length);
void goertzel_uninit(GoertzelFilter* f);
float goertzel_step(GoertzelFilter* f, float x);

#endif /* GOERTZEL_H*/
