#ifndef UTIL_H
#define UTIL_H 1

/**
 * Set the program name, for error reports
 */
void dtmfx_set_program_name(const char* s);

/* Keep these in sequence, ending with DTMF_DEBUG */
#define DTMFX_QUIET 0
#define DTMFX_CHATTY 1
#define DTMFX_DEBUG 2
/**
 * Set the program verbosity, which should be one of the constants
 * DTMFX_QUIET, DTMFX_CHATTY, or DTMFX_DEBUG.
 */
void dtmfx_set_program_verbosity(int i);

/* exported to library users, but not documented */
void error_exit(const char* fmt, ...);

#if DTMFX_IMPLEMENTATION

const char* program_name(void);
int program_verbosity(void);
const unsigned char* map_file(const char* filename, size_t*);
void unmap_file(const unsigned char* mapped_file, size_t file_size);

#endif /* DTMFX_IMPLEMENTATION*/

#endif /* UTIL_H */
