#ifndef UTIL_H
#define UTIL_H 1

#include "jason.h"
typedef uint8_t byte;

#if 0
/**
 * Set the program name, for error reports
 */
void jason_set_program_name(const char* s);

/* Keep these in sequence, ending with DTMF_DEBUG */
#define JASON_QUIET 0
#define JASON_CHATTY 1
#define JASON_DEBUG 2
/**
 * Set the program verbosity, which should be one of the constants
 * JASON_QUIET, JASON_CHATTY, or JASON_DEBUG.
 */
void jason_set_program_verbosity(int i);
#endif

/* exported to library users, but not documented */
void error_exit(const char* fmt, ...);

/* const char* program_name(void); */
/* int program_verbosity(void); */
/* const unsigned char* map_file(const char* filename, size_t*); */
/* void unmap_file(const unsigned char* mapped_file, size_t file_size); */

struct append_buffer {
    size_t alloc;
    size_t len;
    byte* buf;
};
typedef struct append_buffer* StringBuilder;
struct append_buffer* make_append_buffer();
void append_to_buffer_1(StringBuilder, byte);
void append_to_buffer_n(StringBuilder, const byte*, size_t);
void append_to_buffer_c(StringBuilder, char);
void append_to_buffer_s(StringBuilder, const char*);


#endif /* UTIL_H */
